#include <a0b.h>
#include <stdio.h>
#include <getrealtime.h>

a0tPort port;

#define IfError(var, txt)	\
	if (var) fprintf(stderr, "error in a0b:%d (%s)\n", var, txt)

main(int argc, char **argv)
{
	a0tRequest req;
	a0tError ret;
	struct timestruc_t tbegin, tmiddle, tend;
	unsigned long data[2];

	ret = a0Init(&argc, &argv);
	IfError(ret, "a0Init");
	ret = a0NewPort(&port, 7, 0);
	IfError(ret, "a0NewPort");
	ret = a0InitCommit();
	IfError(ret, "a0InitCommit");

	switch (a0SelfNode) {
	case 0:
		readrtc(&tbegin);
		ret = a0Send(&port, 1, 0, NULL, a0_UNSIGNED_LONG, data, 0);
		IfError(ret, "send 0");
		ret = a0Receive(&port, 1, 0, NULL, a0_UNSIGNED_LONG, data, 2);
		IfError(ret, "recv 0");
		readrtc(&tend);
		printf("begin  %10lu %lu\n", tbegin.tv_sec, tbegin.tv_nsec);
		printf("middle %10lu %lu\n", data[0], data[1]);
		printf("end    %10lu %lu\n", tend.tv_sec, tend.tv_nsec);
		break;
	case 1:
		ret = a0Receive(&port, 0, 0, NULL, a0_UNSIGNED_LONG, data, 0);
		IfError(ret, "recv 1");
		readrtc(&tmiddle);
		data[0] = tmiddle.tv_sec;
		data[1] = tmiddle.tv_nsec;
		ret = a0Send(&port, 0, 0, NULL, a0_UNSIGNED_LONG, data, 2);
		IfError(ret, "send 1");
		break;
	}

	a0Terminate();
}
