/*
 * ak-test.c : makes some sends and receives using aKernel
 *
 * by Marcelo Pasin
 * Apache Project, IMAG, Grenoble, France
 * Mar 10, 1996
 *
 * This program tests akTest of aKernel.
 *
 * ak-test is to be executed by two nodes. No argument is expected.
 *
 * The node 0 sends four numbers to the node 1, which sends them back.
 * The node 0  echoes the numbers sent and the node 1 echoes the numbers
 * received.
 */

#include <akernel.h>
#include <stdio.h>


main(int argc, char **argv)
{
	aktHandle handle;
	int i, j, k[10000];

	akInit(&argc, &argv);

	if (akNode) {
		for (i = 0; i < 4; i++) {
			akISend(k, 10000, MPI_INT, 0, 0,
				MPI_COMM_WORLD, &handle, 0, 0);
			j = 0;
			while (!j)	/* busy wait loop */
				akTest(&handle, &j);
			printf("sent %d\n", i);
		}
	} else {
		for (i = 0; i < 4; i++) {
			akIRecv(k, 10000, MPI_INT, 1, 0,
				MPI_COMM_WORLD, &handle, 0, 0);
			j = 0;
			while (!j)	/* busy wait loop */
				akTest(&handle, &j);
			printf("recd %d\n", i);
		}
	}

	akFinalize();
}
