/* Benoit Marchal & Ilan... */


#include <akernel.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "/usr/local/include/getrealtime.h"


void Nom_Complet(char **Res, char *filename, int numero)
{
	char *tmp;

	tmp = (char *) malloc(2 * sizeof(char));
	(*Res) = (char *) malloc((1 + strlen(filename)) * sizeof(char));

	if (numero == -1)
		strcpy((*Res), filename);
	else {
		sprintf(tmp, ".%d", numero);
		strcpy((*Res), filename);
		strcat((*Res), tmp);
	}
}


void LFichier_Entier(char *filename, char **libelle,
		     int numero, int size, int **entier)
{
	FILE *file;
	int *TabEntier;
	int i;
	char *NomComplet, *buffer;

	Nom_Complet(&NomComplet, filename, numero);

	TabEntier = (int *) malloc(size * sizeof(int));
	buffer = (char *) malloc(512 * sizeof(char));
	if (!TabEntier)
		exit(2);

	file = fopen(NomComplet, "r");
	fscanf(file, "%s\n", buffer);
	for (i = 0; i < size; i++)
		fscanf(file, "%d\t", TabEntier + i);
	fclose(file);

	*libelle = buffer;
	*entier = TabEntier;
}


void EFichier_Entier(char *filename, char *libelle,
		     int numero, int size, int *entier)
{
	FILE *file;
	int i;
	char *NomComplet;

	Nom_Complet(&NomComplet, filename, numero);

	if (!entier)
		exit(2);

	file = fopen(NomComplet, "w");
	fprintf(file, "%s\n", libelle);
	for (i = 0; i < size; i++)
		fprintf(file, "%d\t", entier + i);
	fprintf(file, "\n");
	fclose(file);


}


void LFichier_Flottant(char *filename, char **libelle,
		       int numero, int size, float **flottant)
{
	FILE *file;
	float *TabFloat;
	int i;
	char *NomComplet, *buffer;


	Nom_Complet(&NomComplet, filename, numero);

	TabFloat = (float *) malloc(size * sizeof(float));
	buffer = (char *) malloc(512 * sizeof(char));
	if (!TabFloat)
		exit(2);

	file = fopen(NomComplet, "r");
	fscanf(file, "%s\n", buffer);
	for (i = 0; i < size; i++)
		fscanf(file, "%f\t", TabFloat + i);
	fclose(file);

	*libelle = buffer;
	*flottant = TabFloat;
}


void EFichier_Flottant(char *filename, char *libelle,
		       int numero, int size, float *flottant)
{
	FILE *file;
	int i;
	char *NomComplet;

	Nom_Complet(&NomComplet, filename, numero);

	if (!flottant)
		exit(2);

	file = fopen(NomComplet, "w");
	fprintf(file, "%s\n", libelle);
	for (i = 0; i < size; i++)
		fprintf(file, "%f\t", flottant + i);
	fprintf(file, "\n");
	fclose(file);
}


void LFichier_Double(char *filename, char **libelle,
		     int numero, int size, double **doubles)
{
	FILE *file;
	double *TabDouble;
	int i;
	char *NomComplet, *buffer;

	Nom_Complet(&NomComplet, filename, numero);

	TabDouble = (double *) malloc(size * sizeof(double));
	buffer = (char *) malloc(512 * sizeof(char));
	if (!TabDouble)
		exit(2);

	file = fopen(NomComplet, "r");
	fscanf(file, "%s\n", buffer);
	for (i = 0; i < size; i++)
		fscanf(file, "%lf\t", TabDouble + i);
	fclose(file);

	*libelle = buffer;
	*doubles = TabDouble;
}


void EFichier_Double(char *filename, char *libelle,
		     int numero, int size, double *doubles)
{
	FILE *file;
	int i;
	char *NomComplet;

	Nom_Complet(&NomComplet, filename, numero);

	if (!doubles)
		exit(2);

	/*
	   file = fopen(NomComplet, "w");
	 */
	file = stdout;
	fprintf(file, "%s\n", libelle);
	for (i = 0; i < size; i++)
		fprintf(file, "%lf\t", *(doubles + i));
	fprintf(file, "\n");
	/*
	   fclose(file);
	 */
}




/****************************************************************************/
/* Mesure du temps de communication entre 2 processeurs differents sur la   */
/* couche Ath Kernel. Realise 10000 fois, permet d'avoir le temps passe a   */
/* communiquer sur l'ensemble du programme.                                 */
/****************************************************************************/


#define Pair    0
#define Impaire 1
#define TAG     1
/* #define Limite  100 */
#define Limite  10

void Communication(int Position, int taille)
{
	int *buffer, *buffer2, i;
	double temps1[Limite], temps2[Limite], temps[Limite];
	double TDep, TFin, somme, moyenne, res[] =
	{0, 0, 0, 0};
	double TDepBarriere;
	aktHandle handle;

	buffer = (int *) malloc(taille * sizeof(int));
	buffer2 = (int *) malloc(taille * sizeof(int));
	for (i = 0; i < taille; i++)
		*(buffer + i) = rand();

/* Barriere de synchronisation, necessaire pour etre sur que l'ensemble  */
/* des threads travaillent au meme moment.                               */
	TDepBarriere = getrealtime();

	if ((Position % 2) == Pair) {
		akSend(buffer, taille, MPI_INT, (Position + 1),
		       TAG, MPI_COMM_WORLD, &handle);
		akRecv(buffer2, taille, MPI_INT, (Position + 1),
		       TAG, MPI_COMM_WORLD, &handle);
	} else {
		akRecv(buffer2, taille, MPI_INT, (Position - 1),
		       TAG, MPI_COMM_WORLD, &handle);
		akSend(buffer, taille, MPI_INT, (Position - 1),
		       TAG, MPI_COMM_WORLD, &handle);
	}

	TDep = getrealtime();

	if ((Position % 2) == Pair) {
		for (i = 0; i < Limite; i++) {
			akSend(buffer, taille, MPI_INT, (Position + 1),
			       TAG, MPI_COMM_WORLD, &handle);
			akRecv(buffer2, taille, MPI_INT, (Position + 1),
			       TAG, MPI_COMM_WORLD, &handle);
		}
	} else {
		for (i = 0; i < Limite; i++) {
			akRecv(buffer2, taille, MPI_INT, (Position - 1),
			       TAG, MPI_COMM_WORLD, &handle);
			akSend(buffer, taille, MPI_INT, (Position - 1),
			       TAG, MPI_COMM_WORLD, &handle);
		}

	}
	TFin = getrealtime();
	res[0] = TFin - TDep;
	res[1] = 0;
	res[2] = 0;
	res[3] = res[0] / Limite;
	EFichier_Double("Temps.Comm.Int",
			"Total\t\t|tmps syncro\t|tot de com\t|moyenne",
			Position, 4, res);

}


main(int argc, char **argv)
{
	int rank, taille;
	akpthread_t th;

	akpthread_attr_t attr;

	akInit(&argc, &argv);
	rank = akNode;
	if (argc < 2)
		taille = 1;
	else
		taille = atoi(argv[1]);
	printf("Taille : %d \n", taille);

	printf("main: priority %d, sched %d.\n",
	       akpthread_getprio(akpthread_self()),
	       akpthread_getscheduler(akpthread_self()));

	Communication(rank, taille);

	akFinalize();
}
