/*
 * a0parser.h: Header file to a0parser.c
 *
 * parser.c has routines used to parse the command line looking for its options
 * and arguments.Basically they identify options in a simple form "-name <arg>" 
 * or a list form, like, "-name <arg1> <arg2> <arg3> ...".
 *
 * These functions DOESN'T CHANGE argc and argv arguments.
 *
 * by Alexandre Carissimi
 * Apache Project, IMAG, Grenoble, France
 * April 15,1997
 *
 * Modified on:
 *	06/04/98: includes double arguments on single and list forms
 *	29/03/99: float prototypes included
 *
 */

#ifndef _PARSER
#define _PARSER

#include	<string.h>
  
extern int a0ArgFindName(int argc, char **argv, char *name);
extern int a0ArgGetStr(int argc, char **argv, char *name, char **str);
extern int a0ArgGetInt(int argc, char **argv, char *name, int *val);
extern int a0ArgGetIntList(int argc, char **argv, char *name, int n, int *val);
extern int a0ArgGetDouble(int argc, char **argv, char *name, double *val);
extern int a0ArgGetDoubleList(int argc, char **argv, char *name, int n, double *val);
extern int a0ArgGetFloat(int argc, char **argv, char *name, float *val);
extern int a0ArgGetFloatList(int argc, char **argv, char *name, int n, float *val);
#endif		/*_PARSER*/
