/*
 *
 * a0threadattr.h : attributes handling 
 *
 *
 * by Alexandre Carissimi
 * Apache Project, IMAG, Grenoble, France
 * Jun 19, 1998
 *
 */

/* Eliminates multiple includes of this file */

#ifndef	 _A0THREADATTR_H
#define  _A0THREADATTR_H

#include <akernel.h>

/*************************************************************
          definitions
 *************************************************************/

#define     A0SCOPE_SYSTEM     akPTHREAD_SCOPE_SYSTEM
#define	    A0SCOPE_PROCESS    akPTHREAD_SCOPE_PROCESS
#define     A0CREATE_DETACHED  akPTHREAD_CREATE_DETACHED
#define     A0CREATE_JOINABLE  akPTHREAD_CREATE_JOINABLE
#define	    A0INHERIT_SCHED    akPTHREAD_INHERIT_SCHED
#define     A0EXPLICIT_SCHED   akPTHREAD_EXPLICIT_SCHED
#define     A0SCHED_OTHER      akSCHED_OTHER
#define     A0SCHED_RR         akSCHED_RR
#define     A0SCHED_FIFO       akSCHED_FIFO
 
/*************************************************************
          types definition
 *************************************************************/

#define	    a0tThreadAttr       akpthread_attr_t

/*************************************************************
          Function prototypes
 *************************************************************/

extern a0tError	_a0GetSchedPolicy( const a0tThreadAttr *, int *);
extern a0tError	_a0SetSchedPolicy( a0tThreadAttr *, int );
extern a0tError	_a0GetSchedPriority(const a0tThreadAttr *, int *);
extern a0tError	_a0SetSchedPriority( a0tThreadAttr *, int );
extern a0tError	_a0GetSchedScope( const a0tThreadAttr *, int *);
extern a0tError	_a0SetSchedScope( a0tThreadAttr *, int );
extern a0tError	_a0GetInherit( const a0tThreadAttr *, int *);
extern a0tError	_a0SetInherit( a0tThreadAttr *, int );
extern a0tError _a0GetStackSize(const a0tThreadAttr *, size_t *);
extern a0tError _a0SetStackSize( a0tThreadAttr *, size_t );
extern a0tError _a0GetStackAddr(const a0tThreadAttr *, void **);
extern a0tError _a0SetStackAddr( a0tThreadAttr *, void *);
extern a0tError	_a0GetSchedParam( const a0tThread , int *,int *);
extern a0tError _a0SetSchedParam( a0tThread , int, int);

#ifdef A0_SOURCE

/**************************************************************
                Included only for compiling the lib
		 
  Function, defines, typedefs which are private to athapascan0
  features. They aren't visible from user's point of view
 **************************************************************/
#endif /* A0_SOURCE */
#endif /* _A0THREADATTR_H */
