/*
 *
 * _a0format.h : General include file for Formatted Athapascan0
 *
 * by Marcelo Pasin
 * Apache Project, IMAG, Grenoble, France
 * May 23, 1996
 *
 */


/* Eliminates multiple includes of this file */
#ifndef _A0FORMAT_H
#define _A0FORMAT_H


#ifdef __cplusplus
extern "C" {
#endif


#include <ath0.h>
#include <a0fuser.h>
#include <a0fmap.h>
#include <a0fxdr.h>
#include <a0fpipe.h>
#include <a0fmem.h>
#include <a0fread.h>
#include <a0fwrite.h>
#include <a0fcopy.h>
#include <a0flock.h>

/* All the exported function names in the above header files contain 
 * a leading underscore. The following file defines all the 'normal'
 * names to expand to their underscored counterpart.
 */

#ifdef A0_TRACE
#include <a0_perf_fuser.h>
#include <a0_source_perf_fuser.h>
#include <a0_perf_fmap.h>
#include <a0_source_perf_fmap.h>
#include <a0_perf_fxdr.h>
#include <a0_source_perf_fxdr.h>
#include <a0_perf_fpipe.h>
#include <a0_source_perf_fpipe.h>
#include <a0_perf_fmem.h>
#include <a0_source_perf_fmem.h>
#include <a0_perf_flock.h>
#include <a0_source_perf_flock.h>

#include <a0f_perf_macros.h>
#include <a0f_perf_nameshifts.h>

#else
#include <a0f_nameshifts.h>
#endif


#ifdef __cplusplus
} /* extern "C" */
#endif


#endif /* _A0FORMAT_H */
