/*
 * akconfig.h: akernel configuration switches
 *
 * by Alexandre Carissimi
 * Apache Project, IMAG, Grenoble, France
 * Some day on december 1998
 *
 */

/* Eliminates multiple includes of this file */

#ifndef _AKCONFIG_H
#define _AKCONFIG_H

/* Configuring akernel Behaviour according to MPI and
 * Operating system used
 */


#define AKDAEMON_RUN

#if defined(A0_LAM) || defined(A0_MPICH)
#define AK_CANCEL
#endif


/*
 * Solaris 2.6
 */
 
#if defined(A0_TSOL2)
#define AK_DAEMON
#define AK_DAEMON_SCHED	akSCHED_OTHER
#define AK_DAEMON_PRIO	((akSCHED_PRI_OTHER_MAX_NP+akSCHED_PRI_OTHER_MIN_NP)/2)
#define AK_USER_SCHED	akSCHED_OTHER
#define AK_USER_PRIO	((akSCHED_PRI_OTHER_MAX_NP+akSCHED_PRI_OTHER_MIN_NP)/2)
#define AK_DAEMON_SLEEPDELTA 100000
#define	AK_DAEMON_SCOPE akPTHREAD_SCOPE_SYSTEM
#endif

/*
 * Linux 2.x
 */
 
#if defined(A0_TLIN2)
#define AK_DAEMON
#define	AK_DAEMON_SCOPE akPTHREAD_SCOPE_SYSTEM
#define AK_DAEMON_SCHED	akSCHED_OTHER
#define AK_DAEMON_PRIO	((akSCHED_PRI_OTHER_MAX_NP+akSCHED_PRI_OTHER_MIN_NP)/2)
#define AK_USER_SCHED	akSCHED_OTHER
#define AK_USER_PRIO	((akSCHED_PRI_OTHER_MAX_NP+akSCHED_PRI_OTHER_MIN_NP)/2)
#define AK_DAEMON_SLEEPDELTA 100000
#endif

/*
 * Aix 4.x : we don't care about MPIBM be thread-aware. We use
 *           it in the same of a normal MPI. Our measures showed
 *           that was more convinient proced like that.
 */
 
#if defined(A0_TAIX4)
#define AK_DAEMON
#define AK_DAEMON_SCHED	akSCHED_OTHER
#define AK_DAEMON_PRIO	akSCHED_PRI_OTHER_MIN_NP
#define AK_USER_SCHED	akSCHED_OTHER
#define AK_USER_PRIO	akSCHED_PRI_OTHER_MIN_NP
#define	AK_DAEMON_SCOPE akPTHREAD_SCOPE_SYSTEM
#endif

/*
 * Irix 6.5 :
 */
 
#if defined(A0_TSGI6)
#define AK_DAEMON
#define AK_DAEMON_SCHED	akSCHED_OTHER
#define AK_DAEMON_PRIO	((akSCHED_PRI_OTHER_MAX_NP+akSCHED_PRI_OTHER_MIN_NP)/2)
#define AK_USER_SCHED	akSCHED_OTHER
#define AK_USER_PRIO	((akSCHED_PRI_OTHER_MAX_NP+akSCHED_PRI_OTHER_MIN_NP)/2)
#endif

#endif /* _AKCONFIG_H */
