/* global_clock.h */

#include <stdio.h>

#define DEFAULT_WINDOW_SIZE 5
#define DEFAULT_NUMBER_OF_SAMPLES 50
#define DEFAULT_DELAY 1			/* 1 millisecond */

/* Sample point : dates coded as double : sec.micro_sec */
typedef struct {
  double X;		/* time on reference node */
  double Y;		/* time on the host to be calibrated */
} point;


/* Per host statistic table */
typedef struct {
double SX;		/* Sigma of X */
double SY;		/* Sigma of Y */
double SXY;		/* Sigma of XY */
double SXX;		/* Sigma of X^2 */
double SYY;		/* Sigma of Y^2 */
point *win;		/* pointer to smoothing table (window) */
int   *rnk;		/* pointer to the table of ranks of points */
double slope;		/* Y = X * slope + offset */
double offset;
double stderr_slope2;	/* standard error on slope */
double stderr_offset2;	/* standard error on offset */
} statistic;

extern statistic *statistic_table;
extern int window_size;
extern int number_of_points;
extern int number_of_exchanges;
extern int a0NodeNumber;
extern int delay;
extern double node0_initial_time;
extern int initial_time_is_defined;

extern FILE * adjust_input_file;
extern FILE * adjust_output_file;

