#include "global_clock.h"
#include <a0b.h>

void global_compute ()
{
int i;
double slope,sigma2,stderr_slope2;
double offset,sigma2_offset,stderr_offset2;
double SX,SY,SXX,SXY,SYY;

for (i=1;i<a0NodeCount;i++)
{

SX = (statistic_table + i) -> SX;
SY = (statistic_table + i) -> SY;
SXX = (statistic_table + i) -> SXX;
SXY = (statistic_table + i) -> SXY;
SYY = (statistic_table + i) -> SYY;

/************************************************/
/*                  Sig X * Sig Y               */
/* 	Sig XY  -   -------------               */
/*                        n                     */
/*     --------------------------               */
/*                  Sig X * Sig X               */
/* 	Sig XX  -   -------------               */
/*                        n                     */
/************************************************/


slope = (SXY - SX*  SY / (double) number_of_points) /
        (SXX - SX * SX / (double) number_of_points);

(statistic_table + i) -> slope = slope;


/************************************************/
/*      Sig Y             Sig X                */
/*      -----  -  slope * ------                */
/*        n                 n                   */
/************************************************/


offset = (SY - slope * SX)/ (double) number_of_points;

(statistic_table + i) -> offset = offset;


/**************************************************************************/
/*      Sigma2 = Sigma ( Yi - slope Xi - offset)^2                        */
/*									  */
/*      Fully developped :	                                          */
/*      Sig XY - 2 * offset * Sig Y - 2 * slope Sig XY +                  */
/*      n * offset^2 + 2 * slope * offset * Sig X + slope^2 Sig XX        */
/*                                                                        */
/*      Shortcut 							  */
/*      (The art of computer systems performance analysis                 */
/*      Raj Jain   Wiley ed.  p 227                                       */
/*                                                                        */
/*      SYY - offset SY - slope SXY                                       */
/**************************************************************************/

/*
sigma2 = (SXY - 2 * offset * SY - 2 * slope * SXY +
	  (double) number_of_points * offset * offset + 
          2 * slope * offset * SX +
 	  slope * slope * SXX);
*/


sigma2 = SYY - offset * SY - slope * SXY;
sigma2 = sigma2 / (double) (number_of_points - 2);


/*********************************************/
/*	             sigma2                  */  
/*        -----------------------------      */
/*                     Sig X * Sig X         */
/*          Sig XX  -  -------------         */
/*                           n               */
/*********************************************/

/*********************************************/
/* Sigma (Xi - Xmoy)^2 = SXX - 1/n SX * SX   */
/*********************************************/


stderr_slope2 = sigma2 / (SXX -  SX * SX/ (double) number_of_points);

(statistic_table + i) -> stderr_slope2 = stderr_slope2;


/*********************************************************/
/*                        Sig X * Sig X			 */
/*                      --------------------             */
/*             1              n ^ 2                      */
/* sigma2 * ( --- + ---------------------------  )       */
/*             n              Sig X * Sig X              */
/*                Sig XX - --------------------          */
/*                                  n                    */
/*********************************************************/

stderr_offset2 =  sigma2 / 
      ( 1.0 / (double) number_of_points + 
        SX * SX / (double) (number_of_points * number_of_points) /
	(SXX - SX * SX / (double) number_of_points));

(statistic_table + i) -> stderr_offset2 = stderr_offset2;

} /* end for */
} /* end compute */
