#include <a0format.h>


a0tPort myport;


#define MAX	10000
#define TIMES	30


void fill_buffer(int *buf, int size) {

  int i;

  if (size<3) return;

  buf[0] = rand()%MAX;
  buf[1] = rand()%MAX;
  for (i=2; i<size; i++) buf[i] = (i + buf[i-1] * buf[i-2])%MAX;
}


int test_buffer(int *buf, int size) {

  int i, p;

  if (size<3) return 0;

  for (i=2; i<size; i++) {
    p = (i + buf[i-1] * buf[i-2])%MAX;
    if (buf[i] != p) return i+1;
  }
  return 0;
}


int main(int argc, char *argv[]) {

  a0tRequest req;
  int size, ok, times;
  int buffer[MAX];

  a0Init(&argc, &argv);
  a0UseFormats();
  a0NewPort(&myport, 1, 0);
  a0InitCommit();

  /* init a different random seed each time */
  srand(a0SelfNode * time(NULL));

  if (a0SelfNode == 0) {
    while (1) {
      a0FReceive(&myport, 1, 0, &req, A0FInt, &size, 1);
      if (!size) break;
      a0FReceive(&myport, 1, 0, &req, A0FInt, buffer, size);
      ok = test_buffer(buffer, size);
      printf("received %d bytes, %s (%d %d %d %d %d %d)\n", size,
		ok?"error!":"ok.",
		buffer[0], buffer[1], buffer[2],
		buffer[3], buffer[4], buffer[5]);
    }
  }
  if (a0SelfNode == 1) {
    if (argc>1) times = atoi(argv[1]);
    else times = TIMES;

    while (1) {
      if (times--)
        size = (rand() % MAX) + 1;
      else
        size = 0;
      fill_buffer(buffer, size);
      a0FSend(&myport, 0, 0, &req, A0FInt, &size, 1);
      if (!size) break;
      a0FSend(&myport, 0, 0, &req, A0FInt, buffer, size);
    }
  }
  a0Terminate();
}
