/*
 *
 * a0fsamp6.c : Sample of a0b C DMA functions
 *
 * by Marcelo Pasin
 * Apache Project, IMAG, Grenoble, France
 * July 9, 1996
 *
 */

#include <a0format.h>

int main(int argc, char * argv[]) {

  a0tPort port;

  a0Init(&argc, &argv);
  a0UseFormats();
  a0NewPort(&port, 1, 0);
  a0InitCommit();

  if (a0NodeCount == 3) {
    switch (a0SelfNode) {
      case 0: 
      case 1: {
	int table[10];
	int r;
	a0tDMARegion g;
	a0tRequest req;
	char s[80];

	for (r=0; r<10; r++) table[r] = a0SelfNode+10;

	a0NewDMARegion(&g, A0FInt, &table[0], 10);
	printf("send DMA region\n");
	a0FSend(&port, 2, 0, &req, A0FDMARegion, &g, 1);
	printf("wait end\n");
	a0FReceive(&port, 2, 0, &req, A0FInt, &r, 1);

	for (r=0; r<10; r++) sprintf(s+3*r, "%2d ", table[r]);
	printf("%s\n", s);
	break;
      }
      case 2: {
	a0tDMARegion g1, g2;
	a0tRequest req;
	int r;

	printf("receive DMA region2\n");
	a0FReceive(&port, 0, 0, &req, A0FDMARegion, &g1, 1);
	a0FReceive(&port, 1, 0, &req, A0FDMARegion, &g2, 1);
	printf("copy\n");
	a0FCopy(&g1, &req, &g2);
	printf("end\n");
	for (r=0; r<10000; r++);
	a0FSend(&port, 0, 0, &req, A0FInt, &r, 1);
	a0FSend(&port, 1, 0, &req, A0FInt, &r, 1);
      }
    }
  }
  else
    if (!a0SelfNode) printf("must be 3 nodes\n");

  a0Terminate();
  return 0;
}
