#include "akernel.h"
#include <stdio.h>

#define MAXSIZE 32

main(int argc, char **argv) {
  int i, j, s[MAXSIZE], r[MAXSIZE];
  int rank, size;
  aktHandle handle[MAXSIZE];

  akInit(&argc, &argv);
  rank = akNode;
  size = akSize;

  if (size>MAXSIZE) size = MAXSIZE;

  if (!rank) {
    for (i=1; i<size; i++) {
      s[i] = i;
      akISend(s+i, 1, MPI_INT, i, 123, MPI_COMM_WORLD, 0, 0, 0);
    }
    for (i=1; i<size; i++) {
      akIRecv(r+i, 1, MPI_INT, i, 765, MPI_COMM_WORLD, handle+i, 0, 0);
    }
    for (i=1; i<size; i++) akWait(handle+i);

    printf("output:\n");
    for (i=1; i<size; i++) printf("%d ", r[i]);
    printf("\n");
  }
  else {
    akRecv(&j, 1, MPI_INT, 0, 123, MPI_COMM_WORLD, handle);
    i = 2*j;
    akISend(&i, 1, MPI_INT, 0, 765, MPI_COMM_WORLD, 0, 0, 0);
  }

  akFinalize();
}
