/*
 *
 * a0condvar.h : Pthread's conditions
 *
 * by Thierry Gautier
 * Apache Project, IMAG, Grenoble, France
 * Feb 21, 1998 (my birthday!)
 *
 */


/* Eliminates multiple includes of this file */
#ifndef _A0CONDVAR_H
#define _A0CONDVAR_H


#include <akernel.h>
#include "a0error.h"
#include "a0semap.h"


/****************types********************/

typedef akpthread_cond_t a0tCondition;


/****************variables********************/

/****************functions********************/

extern a0tError _a0NewCondition		(a0tCondition *);
extern a0tError _a0DisposeCondition	(a0tCondition *);
extern a0tError _a0SignalCondition	(a0tCondition *);
extern a0tError _a0BroadcastCondition	(a0tCondition *);
extern a0tError _a0WaitCondition	(a0tCondition *, a0tMutex *);
extern a0tError _a0TimedWaitCondition	
	(a0tCondition *, a0tMutex *, const struct timespec *abstime);


#ifdef A0_SOURCE
/****************************************************************************
		Included only for compiling the lib
****************************************************************************/


#endif /* A0_SOURCE */

#endif /* _A0THREAD_H */
