

/* Source file and line identification */

/* #define SOURCE_FILE_NAME  "user_file_name" before the */
/* #include <a0format.h>  triggers source line identification */

/* Macros for source file and line identification */
/* Useful only if source file name available */

#ifndef A0F_PERF_MACROS_H
#define A0F_PERF_MACROS_H

#ifdef SOURCE_FILE_NAME

#define _a0_sperf_NewMapFormat(a,b,c,d) \
	_a0_source_perf_NewMapFormat(file,__LINE__,a,b,c,d)

#define _a0_sperf_SetMapField(a,b,c,d,e,f) \
	_a0_source_perf_SetMapField(file,__LINE__,a,b,c,d,e,f)

#define _a0_sperf_NewDMARegion(a,b,c,d) \
	_a0_source_perf_NewDMARegion(file,__LINE__,a,b,c,d)

#define _a0_sperf_IFReadPart(a,b,c,d,e,f,g) \
	_a0_source_perf_IFReadPart(file,__LINE__,a,b,c,d,e,f,g)

#define _a0_sperf_FReadPart(a,b,c,d,e,f,g) \
	_a0_source_perf_FReadPart(file,__LINE__,a,b,c,d,e,f,g)

#define _a0_sperf_IFRead(a,b,c,d,e) \
	_a0_source_perf_IFRead(file,__LINE__,a,b,c,d,e)

#define _a0_sperf_FRead(a,b,c,d,e) \
	_a0_source_perf_FRead(file,__LINE__,a,b,c,d,e)

#define _a0_sperf_IFWritePart(a,b,c,d,e,f,g) \
	_a0_source_perf_IFWritePart(file,__LINE__,a,b,c,d,e,f,g)

#define _a0_sperf_FWritePart(a,b,c,d,e,f,g) \
	_a0_source_perf_FWritePart(file,__LINE__,a,b,c,d,e,f,g)

#define _a0_sperf_IFWrite(a,b,c,d,e) \
	_a0_source_perf_IFWrite(file,__LINE__,a,b,c,d,e)

#define _a0_sperf_FWrite(a,b,c,d,e) \
	_a0_source_perf_FWrite(file,__LINE__,a,b,c,d,e)

#define _a0_sperf_IFCopyPart(a,b,c,d,e,f,g) \
	_a0_source_perf_IFCopyPart(file,__LINE__,a,b,c,d,e,f,g)

#define _a0_sperf_FCopyPart(a,b,c,d,e,f,g) \
	_a0_source_perf_FCopyPart(file,__LINE__,a,b,c,d,e,f,g)

#define _a0_sperf_IFCopy(a,b,c) \
	_a0_source_perf_IFCopy(file,__LINE__,a,b,c)

#define _a0_sperf_FCopy(a,b,c) \
	_a0_source_perf_FCopy(file,__LINE__,a,b,c)

#define _a0_sperf_IFPut(a,b,c,d,e) \
	_a0_source_perf_IFPut(file,__LINE__,a,b,c,d,e)

#define _a0_sperf_FPut(a,b,c,d,e) \
	_a0_source_perf_FPut(file,__LINE__,a,b,c,d,e)

#define _a0_sperf_IFGet(a,b,c,d,e) \
	_a0_source_perf_IFGet(file,__LINE__,a,b,c,d,e)

#define _a0_sperf_FGet(a,b,c,d,e) \
	_a0_source_perf_FGet(file,__LINE__,a,b,c,d,e)

#define _a0_sperf_Flush(a) \
	_a0_source_perf_Flush(file,__LINE__,a)

#define _a0_sperf_NewPipe(a,b,c,d,e,f,g) \
	_a0_source_perf_NewPipe(file,__LINE__,a,b,c,d,e,f,g)

#define _a0_sperf_DisposePipe(a) \
	_a0_source_perf_DisposePipe(file,__LINE__,a)

#define _a0_sperf_GetFormatSize(a,b,c,d) \
	_a0_source_perf_GetFormatSize(file,__LINE__,a,b,c,d)

#define _a0_sperf_GetFormatOffset(a,b,c,d) \
	_a0_source_perf_GetFormatOffset(file,__LINE__,a,b,c,d)

#define _a0_sperf_UseFormats() \
	_a0_source_perf_UseFormats(file,__LINE__)

#define _a0_sperf_DisposeFormat(a) \
	_a0_source_perf_DisposeFormat(file,__LINE__,a)

#define _a0_sperf_IFSend(a,b,c,d,e,f,g) \
	_a0_source_perf_IFSend(file,__LINE__,a,b,c,d,e,f,g)

#define _a0_sperf_FSend(a,b,c,d,e,f,g) \
	_a0_source_perf_FSend(file,__LINE__,a,b,c,d,e,f,g)

#define _a0_sperf_IFReceive(a,b,c,d,e,f,g) \
	_a0_source_perf_IFReceive(file,__LINE__,a,b,c,d,e,f,g)

#define _a0_sperf_FReceive(a,b,c,d,e,f,g) \
	_a0_source_perf_FReceive(file,__LINE__,a,b,c,d,e,f,g)

#define _a0_sperf_FPack(a,b,c,d) \
	_a0_source_perf_FPack(file,__LINE__,a,b,c,d)

#define _a0_sperf_FUnpack(a,b,c,d) \
	_a0_source_perf_FUnpack(file,__LINE__,a,b,c,d)

#define _a0_sperf_NewFunctionFormat(a,b,c,d,e) \
	_a0_source_perf_NewFunctionFormat(file,__LINE__,a,b,c,d,e)

#define _a0_sperf_SetLockRead(a,b,c,d,e) \
	_a0_source_perf_SetLockRead (file,__LINE__,a,b,c,d,e)

#define _a0_sperf_SetUnlockWrite(a,b,c,d,e) \
	_a0_source_perf_SetUnlockWrite (file,__LINE__,a,b,c,d,e)

#define _a0_sperf_SetLockDMARegion(a,b,c) \
	_a0_source_perf_SetLockDMARegion (file,__LINE__,a,b,c)

#define _a0_sperf_SetLockDMARegionPart(a,b,c,d,e) \
	_a0_source_perf_SetLockDMARegionPart (file,__LINE__,a,b,c,d,e)

#define _a0_sperf_Lock(a,b,c) \
	_a0_source_perf_Lock (file,__LINE__,a,b,c)

#define _a0_sperf_Unlock(a,b,c) \
	_a0_source_perf_Unlock (file,__LINE__,a,b,c)

#define _a0_sperf_ILock(a,b,c) \
	_a0_source_perf_ILock (file,__LINE__,a,b,c)

#define _a0_sperf_IUnlock(a,b,c) \
	_a0_source_perf_IUnlock (file,__LINE__,a,b,c)

#define _a0_sperf_IFReadPartLock(a,b,c,d,e,f,g,h) \
        _a0_source_perf_IFReadPartLock(file,__LINE__,a,b,c,d,e,f,g,h)

#define _a0_sperf_FReadPartLock(a,b,c,d,e,f,g,h) \
        _a0_source_perf_FReadPartLock(file,__LINE__,a,b,c,d,e,f,g,h)

#define _a0_sperf_IFWriteUnlock(a,b,c,d,e) \
	_a0_source_perf_IFWriteUnlock(file,__LINE__,a,b,c,d,e)

#define _a0_sperf_FWriteUnlock(a,b,c,d,e) \
	_a0_source_perf_FWriteUnlock(file,__LINE__,a,b,c,d,e)

#define _a0_sperf_IFReadLock(a,b,c,d,e,f) \
        _a0_source_perf_IFReadLock(file,__LINE__,a,b,c,d,e,f)

#define _a0_sperf_FReadLock(a,b,c,d,e,f) \
        _a0_source_perf_FReadLock(file,__LINE__,a,b,c,d,e,f)

#else	/* SOURCE_FILE_NAME */

/* If source file name not defined, translate source perf calls */
/* into normal perf calls */


#define _a0_sperf_NewMapFormat		_a0_perf_NewMapFormat
#define _a0_sperf_SetMapField		_a0_perf_SetMapField
#define _a0_sperf_NewDMARegion		_a0_perf_NewDMARegion
#define _a0_sperf_IFReadPart		_a0_perf_IFReadPart
#define _a0_sperf_FReadPart		_a0_perf_FReadPart
#define _a0_sperf_IFRead		_a0_perf_IFRead
#define _a0_sperf_FRead			_a0_perf_FRead
#define _a0_sperf_IFWritePart		_a0_perf_IFWritePart
#define _a0_sperf_FWritePart		_a0_perf_FWritePart
#define _a0_sperf_IFWrite		_a0_perf_IFWrite
#define _a0_sperf_FWrite		_a0_perf_FWrite
#define _a0_sperf_IFCopyPart		_a0_perf_IFCopyPart
#define _a0_sperf_FCopyPart		_a0_perf_FCopyPart
#define _a0_sperf_IFCopy		_a0_perf_IFCopy
#define _a0_sperf_FCopy			_a0_perf_FCopy
#define _a0_sperf_IFPut			_a0_perf_IFPut
#define _a0_sperf_FPut			_a0_perf_FPut
#define _a0_sperf_IFGet			_a0_perf_IFGet
#define _a0_sperf_FGet			_a0_perf_FGet
#define _a0_sperf_Flush			_a0_perf_Flush
#define _a0_sperf_NewPipe		_a0_perf_NewPipe
#define _a0_sperf_DisposePipe		_a0_perf_DisposePipe
#define _a0_sperf_GetFormatSize		_a0_perf_GetFormatSize
#define _a0_sperf_GetFormatOffset	_a0_perf_GetFormatOffset
#define _a0_sperf_UseFormats		_a0_perf_UseFormats
#define _a0_sperf_DisposeFormat		_a0_perf_DisposeFormat
#define _a0_sperf_IFSend		_a0_perf_IFSend
#define _a0_sperf_FSend			_a0_perf_FSend
#define _a0_sperf_IFReceive		_a0_perf_IFReceive
#define _a0_sperf_FReceive		_a0_perf_FReceive
#define _a0_sperf_FPack			_a0_perf_FPack
#define _a0_sperf_FUnpack		_a0_perf_FUnpack
#define _a0_sperf_NewFunctionFormat	_a0_perf_NewFunctionFormat
#define _a0_sperf_SetLockRead 		_a0_perf_SetLockRead 
#define _a0_sperf_SetUnlockWrite 	_a0_perf_SetUnlockWrite 
#define _a0_sperf_SetLockDMARegion 	_a0_perf_SetLockDMARegion 
#define _a0_sperf_SetLockDMARegionPart 	_a0_perf_SetLockDMARegionPart 
#define _a0_sperf_Lock 			_a0_perf_Lock 
#define _a0_sperf_Unlock 		_a0_perf_Unlock 
#define _a0_sperf_ILock 		_a0_perf_ILock 
#define _a0_sperf_IFReadPartLock	_a0_perf_IFReadPartLock
#define _a0_sperf_FReadPartLock		_a0_perf_FReadPartLock
#define _a0_sperf_IFWriteUnlock		_a0_perf_IFWriteUnlock
#define _a0_sperf_FWriteUnlock		_a0_perf_FWriteUnlock
#define _a0_sperf_IFReadLock		_a0_perf_IFReadLock
#define _a0_sperf_FReadLock		_a0_perf_FReadLock

#endif	/* SOURCE_FILE_NAME */


#endif /* A0F_PERF_MACROS_H */
