/*
 *
 * akdaemon.h : Daemon thread
 *
 *
 * February 3rd, 1996. Ilan Ginzburg, Marcelo Pasin.
 *
 * Athapascan Kernel.
 *
 */


/* Eliminates multiple includes of this file */
#ifndef _AKDAEMON_H
#define _AKDAEMON_H


/* Advances the communication daemon by waking it up */
extern int akAdvance();


/***************************************************************************/

#ifdef AKERNEL_SOURCE
/****************************************************************************
		Included only for compiling the kernel
****************************************************************************/

#include "akthread.h"
#include "akmpi.h"
#include  <sys/time.h>


/* very boring condition variable, to make the daemon sleep :-) */
extern akpthread_cond_t  akDaemonSleepCond;

/* the NEXT w.c. to be processed in the next loop of the daemon */
extern struct _aktWaitContext *volatile akDaemonNext;

extern akpthread_mutex_t akDaemonRunMutex;

#ifdef AK_NSTOP
extern int volatile akEverybodyBlocked;
#endif


/*****************************functions****************************/

/* Init all date structures needed by the daemon etc...
 * This call must be done before the party begins, i.e. only one thread must
 * be running. */
extern int akDaemonInit(void);
extern int akDaemonTerminate(void);


#endif /* AKERNEL_SOURCE */

#endif /* _AKDAEMON_H */
