/***************************************************************************/
/* File a0_perf_buffer.c                                                     */
/* Philippe Waille 05/07/96                                                */
/***************************************************************************/

#include "a0_perf_buffer.h"
#include "a0_perf_event_macros.h"
#include "a0_perf_event_codes.h"


a0tError _a0_perf_ClearBuffer (a0tBuffer *buffer)
{
a0_perf_begin_event;
rcode =_a0ClearBuffer(buffer);
a0_perf_get_index;
a0_perf_put_event_id(A0_PERF_RECORD_ID_CLEAR_BUFFER);
a0_perf_put_address(buffer);
a0_perf_put_index;
}


a0tError _a0_perf_DisposeBuffer (a0tBuffer *buffer)
{
a0_perf_begin_event;
rcode = _a0DisposeBuffer(buffer);
a0_perf_get_index;
a0_perf_put_event_id(A0_PERF_RECORD_ID_DISPOSEBUFFER);
a0_perf_put_address(buffer);
a0_perf_put_index;
}

a0tError _a0_perf_NewBuffer (a0tBuffer *buffer,a0tBufferType type,long size)
{
a0_perf_begin_event;
rcode = _a0NewBuffer (buffer,type, size);
a0_perf_get_index;
a0_perf_put_event_id(A0_PERF_RECORD_ID_NEWBUFFER);
a0_perf_put_address(buffer);
a0_perf_put_integer(type);
a0_perf_put_integer(size);
a0_perf_put_index;
}

a0tError _a0_perf_Pack (a0tBuffer *buffer,a0tDatatype datatype,void *inbuf, int incount)
{
a0_perf_begin_event;
rcode = _a0Pack(buffer,datatype,inbuf,incount);
a0_perf_get_index;
a0_perf_put_event_id(A0_PERF_RECORD_ID_PACK);
a0_perf_put_address(buffer);
a0_perf_put_integer(incount);
a0_perf_put_index;
}

a0tError _a0_perf_Unpack (a0tBuffer *buffer,
			 a0tDatatype datatype,
			 void *inbuf, 
			 int incount)
{
a0_perf_begin_event;
rcode= _a0Unpack(buffer,datatype,inbuf,incount);
a0_perf_get_index;
a0_perf_put_event_id(A0_PERF_RECORD_ID_UNPACK);
a0_perf_put_address(buffer);
a0_perf_put_integer(incount);
a0_perf_put_index;
}

