/***************************************************************************/
/* File a0_perf_services.c                                                 */
/* Philippe Waille 05/07/96                                                */
/***************************************************************************/

#include "a0_perf_services.h"
#include "a0_perf_event_macros.h"
#include "a0_perf_event_codes.h"


a0tError _a0_perf_NewService(int *Service, a0tRemoteFunction Code,
                        a0tScheduling Sched, int Prio, long StackSize)
{
a0_perf_begin_event;
rcode = _a0NewService(Service,Code,Sched,Prio,StackSize);
a0_perf_get_index;
a0_perf_put_event_id(A0_PERF_RECORD_ID_NEWRRSERVICE);
a0_perf_put_integer(*Service);
a0_perf_put_index;
}


a0tError _a0_perf_StartRemoteUrgent(int node,
                               int service,
			       a0tRequest *requestp,
                               a0tBuffer *buffer)
{
unsigned long serial_no;
a0_perf_begin_event;
rcode = _a0StartRemoteUrgent (node,service,requestp,buffer);
a0_perf_get_index;
a0_perf_put_event_id(A0_PERF_RECORD_ID_REMOTEREQUEST);
a0_perf_put_integer(node);
a0_perf_put_integer(service);
a0_perf_put_address(buffer);
a0_perf_put_address(requestp);
_a0GetRequestSerialNo(requestp,&serial_no);
a0_perf_put_integer(serial_no);
a0_perf_put_index;
}

a0tError _a0_perf_StartRemoteThread (int node,
                                     int service,
                                     a0tScheduling sched,
                                     int prio,
                                     long stack,
				     a0tRequest *requestp,
                                     a0tBuffer *buffer)
{
unsigned long serial_no;
a0_perf_begin_event;
rcode = _a0StartRemoteThread (node,service,sched,prio,stack,requestp,buffer);
a0_perf_get_index;
a0_perf_put_event_id(A0_PERF_RECORD_ID_REMOTETHREADCREATE);
a0_perf_put_integer(node);
a0_perf_put_integer(service);
a0_perf_put_integer(sched);
a0_perf_put_integer(prio);
a0_perf_put_integer(stack);
a0_perf_put_address(buffer);
a0_perf_put_address(requestp);
_a0GetRequestSerialNo(requestp,&serial_no);
a0_perf_put_integer(serial_no);
a0_perf_put_index;
}

a0tError _a0_perf_IStartRemoteUrgent(int node,
                               int service,
			       a0tRequest *requestp,
                               a0tBuffer *buffer)
{
unsigned long serial_no;
a0_perf_begin_event;
rcode = _a0IStartRemoteUrgent (node,service,requestp,buffer);
a0_perf_get_index;
a0_perf_put_event_id(A0_PERF_RECORD_ID_IREMOTEREQUEST);
a0_perf_put_integer(node);
a0_perf_put_integer(service);
a0_perf_put_address(buffer);
a0_perf_put_address(requestp);
_a0GetRequestSerialNo(requestp,&serial_no);
a0_perf_put_integer(serial_no);
a0_perf_put_index;
}

a0tError _a0_perf_IStartRemoteThread (int node,
                                     int service,
                                     a0tScheduling sched,
                                     int prio,
                                     long stack,
				     a0tRequest *requestp,
                                     a0tBuffer *buffer)
{
unsigned long serial_no;
a0_perf_begin_event;
rcode = _a0IStartRemoteThread (node,service,sched,prio,stack,requestp,buffer);
a0_perf_get_index;
a0_perf_put_event_id(A0_PERF_RECORD_ID_IREMOTETHREADCREATE);
a0_perf_put_integer(node);
a0_perf_put_integer(service);
a0_perf_put_integer(sched);
a0_perf_put_integer(prio);
a0_perf_put_integer(stack);
a0_perf_put_address(buffer);
a0_perf_put_address(requestp);
_a0GetRequestSerialNo(requestp,&serial_no);
a0_perf_put_integer(serial_no);
a0_perf_put_index;
}

