/*
 *
 * a0b.h : General include file for Athapascan0
 *
 * by Ilan Ginzburg
 * Apache Project, IMAG, Grenoble, France
 * Feb 15, 1996
 *
 */


/* Eliminates multiple includes of this file */
#ifndef _A0B_H
#define _A0B_H

#undef WANT_MPI2CPP    /*to LAM implantation not consider C++ */
#undef HAVE_MPI_CPP    /*to MPICH implantation not consider C++ */

#ifdef __cplusplus
extern "C" {
#endif


#include <akernel.h>
#include <a0error.h>
#include <a0buffer.h>
#include <a0thread.h>
#include <a0prio.h>
#include <a0semap.h>
#include <a0ports.h>
#include <a0servd.h>
#include <a0urgentd.h>
#include <a0specific.h>
#include <a0init.h>
#include <a0services.h>
#include <a0pt2pt.h>
#include <a0condvar.h>

/* All the exported function names in the above header files contain 
 * a leading underscore.
 * The following file defines all the 'normal' names to expand to their
 * underscored counterpart.
 */
#ifdef A0_TRACE
#include <ath0_perf.h>
#else
#include <basic_nameshifts.h>
#endif


#ifdef __cplusplus
} /* extern "C" */
#endif


#endif /* _A0B_H */
