/*
 *
 * _a0mpi.h : MPI-Athapascan (simple) conversions
 *
 * by Ilan Ginzburg
 * Apache Project, IMAG, Grenoble, France
 * May 29, 1996
 *
 */


/* Eliminates multiple includes of this file */
#ifndef _A0MPI_H
#define _A0MPI_H

#include <akernel.h>
#include "a0error.h"

/************************************************************************/

typedef MPI_Datatype a0tDatatype;

/* Athapascan MPI types */
extern a0tDatatype a0_CHAR;
extern a0tDatatype a0_SHORT;
extern a0tDatatype a0_INT;
extern a0tDatatype a0_LONG;
extern a0tDatatype a0_LONG_LONG_INT;
extern a0tDatatype a0_UNSIGNED_CHAR;
extern a0tDatatype a0_UNSIGNED_SHORT;
extern a0tDatatype a0_UNSIGNED;
extern a0tDatatype a0_UNSIGNED_LONG;
extern a0tDatatype a0_FLOAT;
extern a0tDatatype a0_DOUBLE;
extern a0tDatatype a0_LONG_DOUBLE;
extern a0tDatatype a0_BYTE;
extern a0tDatatype a0_UB;
extern a0tDatatype a0_LB;

/* a0_PORT is the only datatype (other than MPI datatypes) defined in this
 * layer of Athapascan 0.
 */
extern a0tDatatype a0_PORT;

#define A0AnySource	MPI_ANY_SOURCE

/************************************************************************/

#ifdef A0_SOURCE
/* Defines only used for compiling Athapascan0 */

#define	A0MaxDatatypeSize	10


extern a0tError _a0InitDatatypes(void);

/* Creation of an MPI (hmm... Athapascan, sorry) datatype */
extern a0tError _a0NewStructDatatype(a0tDatatype *new, void *base,
					int count, ... );

#endif /* A0_SOURCE */


#endif /* _A0MPI_H */
