#include "a0_perf_fpipe.h"
#include "../basic/a0_perf_event_codes.h"
#include "../basic/a0_perf_event_macros.h"


a0tError _a0_perf_IFPut(a0tPipe *pipe, a0tRequest *request,
	a0tFormat *format, void *address, int count) 

{
unsigned long serial_no;
a0_perf_begin_event;
rcode = _a0IFPutTrace (pipe, request, &serial_no,format, address, count);
a0_perf_get_index;
a0_perf_put_event_id(A0_PERF_RECORD_ID_IFPUT);
a0_perf_put_address(pipe);
a0_perf_put_address(request);
a0_perf_put_address(format);
a0_perf_put_address(address);
a0_perf_put_integer(count);
a0_perf_put_index;
}

a0tError _a0_perf_FPut(a0tPipe *pipe, a0tRequest *request,
	a0tFormat *format, void *address, int count) 

{
unsigned long serial_no;
a0_perf_begin_event;
rcode = _a0FPut (pipe, request, format, address, count);
a0_perf_get_index;
a0_perf_put_event_id(A0_PERF_RECORD_ID_FPUT);
a0_perf_put_address(pipe);
a0_perf_put_address(format);
a0_perf_put_address(address);
a0_perf_put_integer(count);
a0_perf_put_time;
a0_perf_put_index;
}

a0tError _a0_perf_IFGet(a0tPipe *pipe, a0tRequest *request,
	a0tFormat *format, void *address, int count) 
{
unsigned long serial_no;
a0_perf_begin_event;
rcode = _a0IFGetTrace (pipe, request, &serial_no,format, address, count);
a0_perf_get_index;
a0_perf_put_event_id(A0_PERF_RECORD_ID_IFGET);
a0_perf_put_address(pipe);
a0_perf_put_address(request);
a0_perf_put_address(format);
a0_perf_put_address(address);
a0_perf_put_integer(count);
a0_perf_put_index;
}

a0tError _a0_perf_FGet(a0tPipe *pipe, a0tRequest *request,
	a0tFormat *format, void *address, int count) 
{
unsigned long serial_no;
a0_perf_begin_event;
rcode = _a0FGet (pipe, request, format, address, count);
a0_perf_get_index;
a0_perf_put_event_id(A0_PERF_RECORD_ID_FGET);
a0_perf_put_address(pipe);
a0_perf_put_address(format);
a0_perf_put_address(address);
a0_perf_put_integer(count);
a0_perf_put_time;
a0_perf_put_index;
}

a0tError _a0_perf_Flush(a0tPipe *pipe) 
{
a0_perf_begin_event;
rcode = _a0Flush(pipe);
a0_perf_get_index;
a0_perf_put_event_id(A0_PERF_RECORD_ID_FLUSH);
a0_perf_put_address(pipe);
a0_perf_put_time;
a0_perf_put_index;
}

a0tError _a0_perf_NewPipe(a0tPipe *newpipe,
                        a0tPort *port, int node, int tag,
                        int bufsize, int protocol, int prio) 
{
a0tBuffer *bufferp;
unsigned long thread_id = 0;		/* Null thread_id for sync pipes */
a0_perf_begin_event;
rcode = _a0NewPipe(newpipe, port, node, tag, bufsize, protocol, prio);
a0_perf_get_index;
a0_perf_put_event_id(A0_PERF_RECORD_ID_NEWPIPE);
a0_perf_put_address(newpipe);
a0_perf_put_integer(_a0GetPortId1(*port));
a0_perf_put_integer(_a0GetPortId2(*port));
a0_perf_put_integer(node);
a0_perf_put_integer(tag);
a0_perf_put_integer(bufsize);
a0_perf_put_integer(protocol);
a0_perf_put_integer(prio);
if (!(protocol & A0SyncPipe)) _a0GetPipeThreadId(newpipe,&thread_id);
a0_perf_put_integer(thread_id);
_a0GetPipeBuffer(newpipe,&bufferp);
a0_perf_put_address(bufferp);
a0_perf_put_index;
}

a0tError _a0_perf_DisposePipe(a0tPipe *pipe)
{
a0_perf_begin_event;
rcode = _a0DisposePipe(pipe);
a0_perf_get_index;
a0_perf_put_event_id(A0_PERF_RECORD_ID_DISPOSEPIPE);
a0_perf_put_address(pipe);
a0_perf_put_index;
}

